/*
 * AJAX functions for the debugger when viewed in a web browser.
 *
 * $Copyright(c) 2009, 2012 Progress Software Corporation (PSC). All rights reserved.$
 * $Copyright (c) 2013, 2017 Software AG, Darmstadt, Germany and/or Software AG USA Inc., Reston, VA, USA, and/or its subsidiaries and/or its affiliates and/or their licensors.$
 * Use, reproduction, transfer, publication or disclosure is prohibited except as specifically provided for in your License Agreement with Software AG
 */
function addactionbreak()
{
	var form = document.addbreak;
	var req = initXHR();
	addhandler(req);
	req.open('PUT', '/correlator/debug/breakpoint/location');
	if (form.actiononce.checked) {
		req.send('<map name="apama-request"><prop name="action">'
				+form.action.value+'</prop><prop name="owner">'
				+form.owner.value+'</prop><prop name="line">'
				+form.actionline.value+'</prop><prop name="breakonce">true</prop></map>');
	} else {
		req.send('<map name="apama-request"><prop name="action">'
				+form.action.value+'</prop><prop name="owner">'
				+form.owner.value+'</prop><prop name="line">'
				+form.actionline.value+'</prop></map>');
	}
}

function addfilebreak()
{
	var form = document.addbreak;
	var req = initXHR();
	addhandler(req);
	req.open('PUT', '/correlator/debug/breakpoint/location');
	if (form.fileonce.checked) {
		req.send('<map name="apama-request"><prop name="filename">'
				+form.filename.value+'</prop><prop name="line">'
				+form.fileline.value+'</prop><prop name="breakonce">true</prop></map>');
	} else {
		req.send('<map name="apama-request"><prop name="filename">'
				+form.filename.value+'</prop><prop name="line">'
				+form.fileline.value+'</prop></map>');
	} 
}


function addhashbreak()
{
	var form = document.addbreak;
	var req = initXHR();
	addhandler(req);
	req.open('PUT', '/correlator/debug/breakpoint/location');
	if (form.hashonce.checked) {
		req.send('<map name="apama-request"><prop name="filehash">'
				+form.hash.value+'</prop><prop name="line">'
				+form.hashline.value+'</prop><prop name="breakonce">true</prop></map>');
	} else {
		req.send('<map name="apama-request"><prop name="filehash">'
				+form.hash.value+'</prop><prop name="line">'
				+form.hashline.value+'</prop></map>');
	} 
}

function loadCode(targetID, sourceURL, line)
{
	$.get(sourceURL, function(data) {
		// clear the pre and then fill it with our newly downloaded text
		$("#"+targetID).empty();
		$("#"+targetID).append(document.createTextNode(data));
		makeEditor(targetID, true);
	});
}

function makeEditor(targetID, editable)
{
	editAreaLoader.init({
		id : targetID// textarea id
		,syntax: "epl"// syntax to be uses for highgliting
		,start_highlight: true// to display with highlight mode on start-up
		,show_line_colors: true
		,is_editable: editable
		,allow_toggle : editable
		,font_size: 12
		,EA_load_callback: "ealoadcallback"
		,toolbar: "new_document, |, search, go_to_line, fullscreen, |, undo, redo, |, select_font,|, change_smooth_selection, highlight, reset_highlight, word_wrap, |, help"
	});
}

jQuery.parseXML = jQuery.parseXML || function( data ) {
    var xml, tmp;
    if ( !data || typeof data !== "string" ) {
        return null;
    }
    try {
        if ( window.DOMParser ) { // Standard
            tmp = new DOMParser();
            xml = tmp.parseFromString( data , "text/xml" );
        } else { // IE
            xml = new ActiveXObject( "Microsoft.XMLDOM" );
            xml.async = "false";
            xml.loadXML( data );
        }
    } catch( e ) {
        xml = undefined;
    }
    if ( !xml || !xml.documentElement || xml.getElementsByTagName( "parsererror" ).length ) {
        jQuery.error( "Invalid XML: " + data );
    }
    return xml;
};

function compile(targetID, redirect)
{
	var src = editAreaLoader.getValue(targetID)
	putCallback('/correlator/code/inject', src, function handler(req) {
		if (req.readyState == 4) {
//			if (200 != req.status) {
//				alert("Request failed: "+req.statusText);
//			}
			$("#compilationMessages").empty()
			var xmlObject = $.parseXML(req.responseText)
			var $response = $( xmlObject );
			$response.find('prop[name="error"]').each(function() {
				$("#compilationMessages").append(document.createTextNode("ERROR: "+$(this).text()+"\n"));
			});
			$response.find('prop[name="warning"]').each(function() {
				$("#compilationMessages").append(document.createTextNode("WARNING: "+$(this).text()+"\n"));
			});
			if (redirect) {
				$response.find('prop[name="hash"]').each(function() {
					document.location = "/correlator/code/hash/"+$(this).text();
				});
			} else {
				if (200 == req.status) {
					editAreaLoader.setValue(targetID, "")
					$("#codeLink").empty();
					$response.find('prop[name="hash"]').each(function() {
						$("#codeLink").append(("Code: <a href='/correlator/code/hash/"+$(this).text()+"'>"+$(this).text()+"</a>\n"));
					});
				}
			}
		}
	});
}

function deleteName(name, callback, value)
{
	putCallback('/correlator/killMonitor', '<map name="apama-request"><prop name="name">'+name+'</prop></map>', function(req) {
		if (req.readyState == 4) {
			if (200 != req.status) {
				alert("Deletion failed: "+req.statusText);
			} else {
				if ( callback != null ) {
					callback(value);
				}
			}
			$("#compilationMessages").append(document.createTextNode("Deleted: "+name+"\n"));
		}
	});
}

function deleterow(id)
{
	$("#"+id).remove();
}

function deleteall(hash, callback, value)
{
	$.get('/correlator/code/hash/list/'+hash, function(data) {
		var $response = $( data );
		$response.find('map[name="name"]').each(function() {
			deleteName($(this).find('prop[name="name"]').text(), callback, value);
		});
	});
}

function makeToggleButton(id, uri, property)
{
	$.get(uri, function(data) {
		var $response = $( data );
		mode = $response.find('prop[name="'+property+'"]').text();
		if (mode == "true") {
			$("#"+id).empty();
			$("#"+id).append('<input id="dbpbutton" type="button" value="Disable" onclick="del(\''+uri+'\');makeToggleButton(\''+id+'\', \''+uri+'\', \''+property+'\');" />');
		} else {
			$("#"+id).empty();
			$("#"+id).append('<input id="dbpbutton" type="button" value="Enable" onclick="put(\''+uri+'\');makeToggleButton(\''+id+'\', \''+uri+'\', \''+property+'\');" />');
		}
	});
}

